// ------------------------------ GENERAL.HPP	----------------------
// Includes #defs and whatnots used from everywhere in the program

#ifndef _GENERAL_HPP
#define _GENERAL_HPP

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>
#include <string.h>

#include <iostream.h>

// general #defs
#define MAXFILENAME 100

// general type definition; #undefs added by Thomas Pederson
#ifdef FALSE
#undef FALSE
#endif
#ifdef TRUE
#undef TRUE
#endif
typedef enum mybool { FALSE=0, TRUE };
typedef char fileName[MAXFILENAME];

#include "daz-random.hpp"	// random generation class, by Darren Platt
// portable definition of a random generation function
#define myrand( x ) ( my_rand() % (x) ) 

// portable definition of random seed generator, using ANSI C funcs
#define mysrand()  seed_random( (unsigned) time( (time_t) 0 ) )


// portable definition of the directory separator
#ifdef __MSDOS__
#define SEP '\\'
#else
#define SEP '/'
#endif


// templates galore

// ---------------------------------------------
template <class swapType>
static void swap( swapType& _s1, swapType& _s2 ) {
// -- swaps contents of the two variables
// -----------------------------------------------
    swapType tmp = _s1;
    _s1 = _s2;
    _s2 = tmp;
}

#endif // _GENERAL_HPP
